/********************************** (C) COPYRIGHT *******************************
* File Name          : kernel.C
* Author             : tech11
* Version            : V1.0
* Date               : 2013/07/01
* Description        : ʼMCUIO
*******************************************************************************/


/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>

#include "stm32f10x_lib.h"
#include "platform_config.h"
#include "typedef.h"
#include  "kernel.h"

/*********************************************************************
*Function Name   : RCC_Configuration
* Input          : -- Globe: NULL
	               -- Local: 
	               -- dat:
* Output         : None 
* Return         :
	               -- Globe: NULL
	               -- Local: NULL
* Description    : 
**********************************************************************/
ErrorStatus HSEStartUpStatus;

unsigned char  RCC_Configuration(void)
{
	unsigned long	mTimeOutCnt;			/* ʱ */
  	unsigned char   err;   					/* Դ */
	unsigned char	status;

	status = 0x00;							/* ʼΪȥ */
	for(err = 0; err < 3; err ++ )
	{
	  	/* RCC system reset(for debug purpose) */
	  	RCC_DeInit();
	
	  	/* Enable HSE */
	  	RCC_HSEConfig(RCC_HSE_ON);	/*RCC->CR Ĵ */
	  	
	  	/* Wait till HSE is ready */
	  	HSEStartUpStatus = RCC_WaitForHSEStartUp();
	
	  	if (HSEStartUpStatus == SUCCESS)
	  	{
	    	/* Enable Prefetch Buffer */
	    	FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
	
	    	/* Flash 2 wait state */
	    	FLASH_SetLatency(FLASH_Latency_2);
	
	    	/* HCLK = SYSCLK */
	    	RCC_HCLKConfig(RCC_SYSCLK_Div1);
	
		    /* PCLK2 = HCLK */
		    RCC_PCLK2Config(RCC_HCLK_Div1);
		
		    /* PCLK1 = HCLK/2 */
		    RCC_PCLK1Config(RCC_HCLK_Div2);
		
		    /* PLLCLK = 8MHz * 9 = 72 MHz */
		    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);
		
		    /* Enable PLL */
		    RCC_PLLCmd(ENABLE);
				
			mTimeOutCnt = 0x00FFFFFF;			
		    /* Wait till PLL is ready */
		    while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET && mTimeOutCnt -- )
		    {
			}
			if( mTimeOutCnt != 0 )
			{		 		
		    	/* Select PLL as system clock source */
		    	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
		
				mTimeOutCnt = 0x00FFFFFF;
		    	/* Wait till PLL is used as system clock source */
		    	while (RCC_GetSYSCLKSource() != 0x08  && mTimeOutCnt -- )
		    	{
				}
				if( mTimeOutCnt != 0 )		/* Enable GPIOA, GPIOC andSART1 clock */
				{
					status = 0x00;
					break;
				}
				else
				{
					status = 0x01;							/* ʱ,ȴ */
				}
			}
			else
			{
				status = 0x01;				 				/* ʱ,ȴ */
			}
		}
		else
		{
			status = 0x01;									/* ,ȴ */
		}		
	}
	/* ʱлⲿ,ԼƵǷɹ,ȥ򿪸ʱ */
	
//	RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA| RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_USART1 , ENABLE );

	RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | RCC_APB2Periph_USART1 , ENABLE );
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1 | RCC_APB1Periph_I2C2, ENABLE);
    /* AFIO clock enable */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
	/* TIM1 clock enable */
//	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);				/*ʹTIM1*/
	
	/* TIM2 clock enable */
//	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);				/*ʹTIM2*/

	/* TIM4 clock enable */
//	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);				/*ʹTIM4*/
	
	/* TIM3 clock enable */
//	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);				/*ʹTIM3*/
	return(status );
} 

/*********************************************************************
*Function Name   : NVIC_Configuration
* Input          : -- Globe: NULL
	               -- Local: 
	               -- dat:
* Output         : None 
* Return         :
	               -- Globe: NULL
	               -- Local: NULL
* Description    : 
**********************************************************************/
void	NVIC_Configuration( void )
{
    NVIC_InitTypeDef	NVIC_InitStructure;

//	NVIC_SetVectorTable( NVIC_VectTab_FLASH, 0x0000 );
 	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0000); 
	/* Enable the USART1 Interrupt */
    /* Deinitializes the NVIC */
    NVIC_DeInit();

	/* Configure the NVIC Preemption Priority Bits[ȼ] */  
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	
	/* Enable the TIM2 gloabal Interrupt [TIM2ȫж]*/
	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQChannel;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	/* Enable the USART1 Interrupt */
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQChannel;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);


}
/*********************************************************************
*Function Name   : USART_Configuration
* Input          : -- Globe: NULL
	               -- Local: 
	               -- dat:
* Output         : None 
* Return         :
	               -- Globe: NULL
	               -- Local: NULL
* Description    : 
					USART1 configured as follow:
					-- Word Length = 8 Bits
					-- 1 Stop Bit
					-- No parity
					-- BaudRate = 115200 baud
					-- Receive and transmit enabled
**********************************************************************/
void	USART_Configuration( void )
{
	USART_InitTypeDef USART_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructure;

	/* USART1 Hard configured: */
	/* Configure USART1 Rx (PA10) as input floating */
	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN_FLOATING;
	GPIO_Init( GPIOA, &GPIO_InitStructure );

	/* Configure USART1 Tx (PA9) as alternate function push-pull */
	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;
	GPIO_Init( GPIOA, &GPIO_InitStructure );

  	/* USART1 configured as follow:
        - BaudRate = 115200 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled
        - USART Clock disabled
        - USART CPOL: Clock is active low
        - USART CPHA: Data is captured on the middle 
        - USART LastBit: The clock pulse of the last data bit is not output to 
                         the SCLK pin
  	*/

	USART_InitStructure.USART_BaudRate = 115200;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init( USART1, &USART_InitStructure );
	
	USART_ITConfig( USART1, USART_IT_RXNE, ENABLE );			 /* ʹUSART1ж */
	
	/* Enable USART1 */
	USART_Cmd( USART1, ENABLE ); 
}

/*********************************************************************
*Function Name   : UartRecvChar
* Input          : -- Globe: NULL
	               -- Local: 
	               -- dat:
* Output         : None 
* Return         :
	               -- Globe: NULL
	               -- Local: NULL
* Description    : I2C2
**********************************************************************/
void GPIO_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE); 
		
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10 | GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}

/*********************************************************************
*Function Name   : UartRecvChar
* Input          : -- Globe: NULL
	               -- Local: 
	               -- dat:
* Output         : None 
* Return         :
	               -- Globe: NULL
	               -- Local: NULL
* Description    : 
**********************************************************************/
unsigned char	UartRecvChar( void )
{
	while ( !( USART1->SR & USART_FLAG_RXNE ) );
	return ( USART_ReceiveData( USART1 ) );
}


/*********************************************************************
*Function Name   : UartSendChar
* Input          : -- Globe: NULL
	               -- Local: 
	               -- dat:
* Output         : None 
* Return         :
	               -- Globe: NULL
	               -- Local: NULL
* Description    : 
**********************************************************************/
int	UartSendChar( int ch )
{               
	/* Write character to Serial Port     */
    USART_SendData( USART1, ( unsigned char )ch );
	while ( !( USART1->SR & USART_FLAG_TXE ) );

	return ( ch );
}

#ifdef  DEBUG
/*******************************************************************************
* Function Name  : assert_failed
* Description    : Reports the name of the source file and the source line number
*                  where the assert_param error has occurred.
* Input          : - file: pointer to the source file name
*                  - line: assert_param error line source number
* Output         : None
* Return         : None
*******************************************************************************/
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif























