/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : tech11
* Version            : V1.0
* Date               : 2013/07/01
* Description        : CH9343 I2C ԷղԳ 
*                      (1)STM32ƬCԵĲԳ
                       (2)Examples by KEIL3_V3.40;    
*                      (3)STM32ӲI2C2豸ӿCH9343I2CӿڵԷ;
*                      (4)1Ϣ,115200bps;
*******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "stm32f10x_lib.h"
#include <stdio.h>

/*******************************************************************************/
/*  */
/* Private typedef*************************************************************/
typedef enum { FAILED = 0, PASSED = !FAILED} TestStatus;

/* Private define **************************************************************/
#define I2C1_SLAVE_ADDRESS7    0x30
#define I2C2_SLAVE1_ADDRESS7   0x30
#define I2C2_SLAVE2_ADDRESS7   0x22
#define BufferSize             300
#define ClockSpeed             200000
/* Private macro **************************************************************/
/* Private variables **********************************************************/
I2C_InitTypeDef  I2C_InitStructure;
u8 I2C1_Buffer1_Tx[BufferSize] = {1,2,3,4}, I2C1_Buffer2_Tx[BufferSize] = {5,6,7,8};
u8 I2C2_Buffer1_Rx[BufferSize], I2C2_Buffer2_Rx[BufferSize];
u16 Tx_Idx = 0, Rx_Idx = 0;
volatile TestStatus TransferStatus1 = FAILED, TransferStatus2 = FAILED;   

/*******************************************************************************/
/*  */
void RCC_Configuration(void);
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void USART_Configuration( void );
int  UartSendChar( int ch );
int  fputc( int ch, FILE *f ) { return( UartSendChar( ch ) ); }

/*******************************************************************************
* Function Name  : Delay
* Description    : ʱ
* Input          : ʱʱ time
* Output         : None
* Return         : None
*******************************************************************************/
void Delay( u32 time )
{   
    u32 i, j;
    for(j=0;j<time;j++)
    {
        for(i=0;i<12;i++);
    }
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void)
{
    /* System clocks configuration *************************************************/
    RCC_Configuration( );
    
    /* NVIC configuration *********************************************************/
    NVIC_Configuration( );
    
    /* GPIO configuration *********************************************************/
    GPIO_Configuration( );
    USART_Configuration( );    
    /* Enable I2C2 ****************************************************************/
    printf("Start CH9343 I2C Test!\n");
    while(1)
    {
        I2C_Cmd(I2C2, ENABLE);
        /* I2C2 configuration *********************************************************/
        I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
        I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;
        I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
        I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
        I2C_InitStructure.I2C_ClockSpeed = ClockSpeed;
        /* I2C2 configuration *********************************************************/
        I2C_InitStructure.I2C_OwnAddress1 = I2C2_SLAVE1_ADDRESS7;
        I2C_Init(I2C2, &I2C_InitStructure);
        
        /* I2C2 second address configuration */
        I2C_OwnAddress2Config(I2C2, I2C2_SLAVE2_ADDRESS7);
        /* Enable I2C2 Dual address */
        I2C_DualAddressCmd(I2C2, ENABLE);
         
        printf("I2C2 configuration sucess Start Receive data!\n");
        while(!I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_RECEIVER_ADDRESS_MATCHED)) ; 
        
        /* Send data */
        while(!I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_BYTE_RECEIVED));  
        /* Store received data on I2C2 */
        I2C2_Buffer1_Rx[Rx_Idx++] = I2C_ReceiveData(I2C2);
        
        
    
        while(1)
        {
            /* Store received data on I2C2 */
            while(!I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_BYTE_RECEIVED))
	        {
			    /*Detected Stop Event */
				if(I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_STOP_DETECTED)!=0)goto A;
			}
            I2C2_Buffer1_Rx[Rx_Idx++] = I2C_ReceiveData(I2C2); 
         }
               
        /* Clear I2C2 STOPF flag */
A:      I2C_ClearFlag(I2C2, I2C_FLAG_STOPF);
        
        printf("I2C2  Start Send data!\n");
        while(!I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_RECEIVER_ADDRESS_MATCHED)) ; 
        
        while(!I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_BYTE_RECEIVED));  
    
        /* Store received data on I2C2 */
        I2C2_Buffer2_Rx[1] = I2C_ReceiveData(I2C2);    
        while(!I2C_CheckEvent(I2C2,I2C_EVENT_SLAVE_TRANSMITTER_ADDRESS_MATCHED)); 
        /* Send data */
        Tx_Idx++;
        while (Tx_Idx < Rx_Idx)
        {
            /* Test on I2C2 EV2 and clear it */
            while(!I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_BYTE_TRANSMITTING)); 
            /* Store received data on I2C2 */
            I2C_SendData(I2C2, I2C2_Buffer1_Rx[Tx_Idx++]);
        } 
        while(!I2C_CheckEvent(I2C2, I2C_EVENT_SLAVE_ACK_FAILURE)); 
        I2C_ClearFlag(I2C2,I2C_FLAG_AF);
        Tx_Idx=0;   
        Rx_Idx=0;
        I2C_Cmd(I2C2, DISABLE);
    }
}
