/********************************** (C) COPYRIGHT *******************************
* File Name          : CH563.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/08/01
* Description        : CH9343 SPIշ
*                      (1)CH563 SPI Examples by KEIL3_V3.40;    
*                      (2)1Ϣ,115200bps;
*                      (3)CH563 SPI0豸ģʽCH9343SPIӣշ;
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "SRC\CH563SFR.H"
#include "SRC\SYSFREQ.H"

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while(1);
}


/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART1_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART1_DIV = 1;                                                           /* ԤƵ */
    R8_UART1_DLM = x>>8;
    R8_UART1_DLL = x&0xff;

    R8_UART1_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART1_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR | RB_FCR_FIFO_EN ;
                                                                                /* FIFOΪ28巢ͺͽFIFOFIFOʹ */
    R8_UART1_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD1|TXD1;                                                    /* RXD1 schmitt input, TXD1 slow rate */
    R32_PB_PD &= ~ RXD1;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD1;                                                         /* TXD1 output enable */
}
/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int fputc( int c, FILE *f )
{
    R8_UART1_THR = c;                                                           /*  */
    while( ( R8_UART1_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : SPI0_SLAVE_INIT
* Description    : SPI0豸ģʽʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/                          
void SPI0_SLAVE_INIT( void )
{

    R8_SPI0_CTRL_DMA = 0;
    R8_SPI0_INTER_EN = 0;
//  R8_SPI0_CLOCK_DIV = 0x05;  /* SCK=24MHz@100MHz */
    R8_SPI0_INT_FLAG = 0xFF;
//  R8_SPI0_CTRL_MOD = (RB_SPI_MISO_OE | RB_SPI_MODE_SLAVE|RB_SPI_FIFO_DIR);    /* ģʽüĴ,豸ģʽ,ĬΪ */
    R8_SPI0_CTRL_MOD |= ( RB_SPI_MISO_OE | RB_SPI_MODE_SLAVE );                 /* ģʽüĴ,豸ģʽ */
    R8_SPI0_CTRL_MOD |= ( RB_SPI_FIFO_DIR | RB_SPI_ALL_CLEAR );                 /* FIFO,FIFOĬΪ*/
    R8_SPI0_CTRL_MOD &= ~RB_SPI_ALL_CLEAR ;    
    R32_PB_DIR &= ~SCS;  /* SCSSCK0MOSI input enable */
    R32_PB_PU  |= SCS;
    R32_PB_DIR &= ~SCK0;
    R32_PB_DIR &= ~MOSI;
    R32_PB_DIR |= MISO;  /* MISO output enable */
    R32_PB_OUT |= MISO;    

}
/*******************************************************************************
* Function Name  : main
* Description    : Main routine.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int    main( ) 
{
    UINT32 k, i = 0,Rcount = 0;
    UINT8  cnt, count, buf[ 1024 ];
    Delay_ms( 100 );
    mInitSTDIO( );                            /* Ϊüͨڼʾ */  
    printf( "CH9343 SPI Master Test Start!\n" );
	SPI0_SLAVE_INIT( );	                      /* SPI0ڳʼ */ 
						   
#if 0
	printf( "	Step1: Test SPI Master Tran Data\n" );
	k = 0;
	while(1)
	{
	    printf( "		Wait CS Low: %d\n", ( UINT16 )k );
		SPI0_SLAVE_INIT( );	                      /* SPI0ڳʼ */ 
		while( ( R32_PB_PIN&SCS ) != 0 );         /* SCSΪ͵ƽʼ */
	    while( 1 )
		{   
			R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR;
			if( R8_SPI0_FIFO_COUNT != 0 )  /*жϵֽڴж*/
			{   
				buf[ Rcount ] = R8_SPI0_FIFO;    /* 洢ݵbuf */   
				Rcount ++;
			} 
			if(( R32_PB_PIN & SCS )&&( R8_SPI0_FIFO_COUNT==0 ))  break;				 /* ߵƽѭ */ 

		}
		k ++;
#if 1			
		printf("Over = %d\n",R8_SPI0_FIFO_COUNT);		
		for(i = 0;i < Rcount;i ++)					 /* ӡյ,շдӡ*/
		{                                              
		    printf("Buf[ %d ] = %X\n",i,(UINT16)buf[ i ]);
		}
#endif
	    Rcount = 0; 
	}
#else
	R8_SPI0_CTRL_MOD &= ~RB_SPI_FIFO_DIR;     /* FIFOΪ׼ */
	cnt = 32;
	printf( "	Step2: Test SPI Master Recv Data: %ld\n", cnt );
	for(i = 0;i < cnt;i ++)			       /* FIFO */
	{
		R8_SPI0_FIFO = '0' + i;
	}
	k = 0;
	while( 1 )
	{
		count = 32;
		printf( "		Wait CS Low: %d\n", ( UINT16 )k );
		while( ( R32_PB_PIN&SCS )!=0 );           /* SCSΪ͵ƽʼ */;
		while( 1 )
		{
			while( R8_SPI0_FIFO_COUNT < 32 )
			{
				R8_SPI0_FIFO = '0' + count - 32;   /* ȡ */
				count ++;
			}
			if( R32_PB_PIN & SCS) break;		  /* ߵƽѭ */
		}
		k ++;
		printf( "count: %d\n", count-R8_SPI0_FIFO_COUNT );
	}
#endif   
}
/*********************************** endfile **********************************/
