/********************************** (C) COPYRIGHT *******************************
* File Name          : CH563.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/08/01
* Description        : CH9343 SPI Գ
*                      (1)CH563CԵĲԳ
*                      (2)Examples by KEIL3_V3.40;    
*                      (3)CH563SPI0CH9343SPIӻӣշ;
*                      (4)1Ϣ,115200bps;
*******************************************************************************/

/******************************************************************************/
/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "..\SRC\CH563SFR.H"
#include "..\SRC\SYSFREQ.H"

/******************************************************************************/
#define	LED_MAIN_WORK_INIT( )	{ R32_PB_DIR |= ( 1<<3 ); R32_PB_OUT |= ( 1<<3 ); }		/* ָʾ */
#define	LED_MAIN_WORK_ACT( )	( R32_PB_CLR |= ( 1<<3 ) )
#define	LED_MAIN_WORK_INACT( )	( R32_PB_OUT |= ( 1<<3 ) )
#define	LED_MAIN_WORK_TWK( )	( R32_PB_OUT ^= ( 1<<3 ) )

/* SPIͬź */
#define	DEF_SPI0S_T_SYN_PU( )	{ R32_PB_PU |= 1<<5; }		        /* SPI0ӻͬź */
#define	DEF_SPI0S_T_SYN_IN( )	{ R32_PB_DIR &= ~( 1<<5 ); }		/* SPI0ӻͬź */
#define	DEF_SPI0S_T_SYN_GET( )	( R32_PB_PIN & ( 1<<5 ) )		    /* ȡSPI0ӻ״̬ */
#define	DEF_SPI0S_R_SYN_PU( )	{ R32_PB_PU |= 1<<6; }		        /* SPI0ӻͬź */
#define	DEF_SPI0S_R_SYN_IN( )	{ R32_PB_DIR &= ~( 1<<6 ); }		/* SPI0ӻͬź */
#define	DEF_SPI0S_R_SYN_GET( )	( R32_PB_PIN & ( 1<<6 ) )		    /* ȡSPI0ӻ״̬ */

UINT8	gDataBuf[ 1024 ];
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while(1);
}


/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( void )
{
	UINT32	x, x2;
	x = 10 * FREQ_SYS * 2 / 16 / 115200;  /* 115200bps */
	x2 = x % 10;
	x /= 10;
	if ( x2 >= 5 ) x ++;  /*  */
	R8_UART1_LCR = 0x80;  /* DLABλ1 */
	R8_UART1_DIV = 1;     /* ԤƵ	 */
	R8_UART1_DLM = x>>8;
	R8_UART1_DLL = x&0xff;
	R8_UART1_LCR = 0x03;
	R8_UART1_FCR = 0xC7;
	R8_UART1_IER = RB_IER_TXD_EN;  /* TXD enable */

	R32_PB_SMT |= RXD1 | TXD1;  /* RXD0 schmitt input, TXD0 slow rate */
	R32_PB_PD &= ~ RXD1;  /* disable pulldown for RXD0, keep pullup	*/
	R32_PB_DIR |= TXD1;  /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
	R8_UART1_THR = c;                                          /*  */
	while( ( R8_UART1_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );       /* ȴݷ */
	return( c );
}

/*******************************************************************************
* Function Name  : SPI_MASTER_INIT
* Description    : SPI0ģʽʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPI_MASTER_INIT ( )
{
    R8_SPI0_CTRL_MOD = RB_SPI_MOSI_OE | RB_SPI_SCK_OE;		/* MOSISCK0ʹ mode0 */
/* ʱ */
	R8_SPI0_CLOCK_DIV = 100;		/* 100Ƶ100/100=1M */
//	R8_SPI0_CLOCK_DIV = 50;		/* 50Ƶ100/50=2M */
//  R8_SPI0_CLOCK_DIV = 25;		/* 5Ƶ100/25=4M */
//  R8_SPI0_CLOCK_DIV = 20;		/* 5Ƶ100/20=5M */
	R8_SPI0_CLOCK_DIV = 10;		/* 10Ƶ100/10=10M */
//  R8_SPI0_CLOCK_DIV = 7;		/* 10Ƶ100/7=14.3M */
//  R8_SPI0_CLOCK_DIV = 6;		/* 10Ƶ100/6=16.7M */
//  R8_SPI0_CLOCK_DIV = 5;		/* 5Ƶ100/5=20M */
//	R8_SPI0_CLOCK_DIV = 4;		/* 4Ƶ100/4=25Mֵ֧Ƶ */
	R8_SPI0_CTRL_DMA = 0x00;		/* DMAʽ */
	R32_PB_PU |= SCS;
	R32_PB_OUT |= SCS;
	R32_PB_DIR |= MOSI | SCK0 | SCS;		/* MOSIPB14SCK0PB13SCSPB12 */
	R32_PB_DIR &= ~MISO;		/* MISO(PB15) */
}

/*******************************************************************************
* Function Name  : PeriTestKeyInit
* Description    : ųʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void	PeriTestKeyInit( void )
{
	R32_PB_DIR &= ~( 1<<7 );
	R32_PB_OUT |= 1<<7;
	R32_PB_PU |= 1<<7;
}

/*******************************************************************************
* Function Name  : PeriTestKeyGet
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8	PeriTestKeyGet( void )
{
	if( R32_PB_PIN & ( 1<<7 ) ) return( 0 );
	Delay_ms( 10 );
	if( R32_PB_PIN & ( 1<<7 ) ) return( 0 );
	Delay_ms( 10 );
	while( !( R32_PB_PIN & ( 1<<7 ) ) );
	Delay_ms( 10 );
	if( !( R32_PB_PIN & ( 1<<7 ) ) ) return( 0 );
	return( 1 );
}

/*******************************************************************************
* Function Name  : Spim0HwTranByte
* Description    : SPIһֽ                   
* Input          :  dat
* Output         : None
* Return         : None
*******************************************************************************/
void	Spim0HwTranByte( UINT8 dat )
{

    R8_SPI0_CTRL_MOD &= ~RB_SPI_FIFO_DIR;                                        /* λ0 */
    R8_SPI0_BUFFER = dat;                                                       /* дݲ */
    while( R8_SPI0_INT_FLAG & RB_SPI_FREE ==0 );                                   /* ȴݴ */
    R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR;                                         /* ĬϷΪ */
}

/*******************************************************************************
* Function Name  : Spim0HwRecvByte
* Description    : SPIһֽ                   
* Input          : None
* Output         : None
* Return         : յ
*******************************************************************************/
UINT8	Spim0HwRecvByte( void )
{
	R8_SPI0_FIFO = 0xFF;
	R16_SPI0_TOTAL_CNT = 1;
	while( R8_SPI0_FIFO_COUNT );		/* ȴݷ */
	return( R8_SPI0_BUFFER );
}

/*******************************************************************************
* Function Name  : CH9343Spi0SlvTest
* Description    : CH9343 SPIӻģʽԺ                   
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void	CH9343Spi0SlvTest( void )
{
	UINT32	i, k, cnt, c=0;

	printf( "CH9343 Spi Slv Test\n" );
	SPI_MASTER_INIT ( );
	DEF_SPI0S_T_SYN_PU( );		/* SPI0ӻͬź */
	DEF_SPI0S_T_SYN_IN( );		/* SPI0ӻͬź */
	DEF_SPI0S_R_SYN_PU( );		/* SPI0ӻͬź */
	DEF_SPI0S_R_SYN_IN( );		/* SPI0ӻͬź */

#if 1
	cnt = 16;
	printf( "	Step1: Test Spi Slave Recv Data: %ld\n", cnt );
	while( 1 )
	{
		printf( "		Wait Start Key Act\r\n" );
		while( !PeriTestKeyGet( ) );
		k = 0;
		while( 1 )
		{
#if 1
			printf( "		Wait Key Act: %d\n", ( UINT16 )k );
			while( !PeriTestKeyGet( ) );
#endif
			if( ( k % 20 ) == 0 ) LED_MAIN_WORK_TWK( );
			while( DEF_SPI0S_R_SYN_GET( ) );		/* ȴӻͬźЧ */
			R32_PB_CLR |= SCS;		/* Ƭѡʹ */
			for( i = 0; i < cnt; i ++ )
			{
				while( DEF_SPI0S_R_SYN_GET( ) );		/* ȴӻͬźЧ */
				Spim0HwTranByte( 'A'+ ( i & 0x0F ) );
				while( !DEF_SPI0S_R_SYN_GET( ) );		/* ȴӻͬźЧ */
		    }
			R32_PB_OUT |= SCS; 		/* SPI0ƬѡЧ */
			k ++;
			if( PeriTestKeyGet( ) ) break;		/* ֹͣ */
		}
		printf( "Total Cnt: %ld\r\n", k * cnt );
	}
#else
	cnt = 16;
	cnt = cnt < sizeof( gDataBuf ) ? cnt : sizeof( gDataBuf );
	printf( "	Step2: Test Spi0 Slave Tran Data: %d Byte\n", cnt );
	k = 0;
	while( 1 )
	{
		k = 0;
		printf( "		Wait Key Act: %d\n", ( UINT16 )k );
		while( !PeriTestKeyGet( ) );
		while( 1 )
		{
			for( i = 0; i < cnt; i ++ ) memset( &gDataBuf[ 0 ], 0x00, sizeof( gDataBuf ) );
#if 0
			printf( "		Wait Key Act: %d\n", ( UINT16 )k ++ );
			while( !PeriTestKeyGet( ) );
			printf( "Wait Tx Syn\n" );
#endif
			if( ( k % 20 ) == 0 ) LED_MAIN_WORK_TWK( );
			while( DEF_SPI0S_T_SYN_GET( ) );		/* ȴӻͬźǷЧЧȴ */
			R32_PB_CLR |= SCS; 		/* Ƭѡʹ */
			for( i = 0; i < cnt; i ++ )
			{
				while( DEF_SPI0S_T_SYN_GET( ) );		/* ȴӻͬźЧ */
				gDataBuf[ i ] = Spim0HwRecvByte( );
				while( !DEF_SPI0S_T_SYN_GET( ) );		/* ȴӻͬźЧ */
		    }
			R32_PB_OUT |= SCS; 		/* SPI0ƬѡЧ */
			k ++;
#if 1
		    printf( "Over\n" );
			printf( "	gDataBuf: " );
			for( i = 0; i < cnt; i ++ ) printf( "0x%02X  ", ( UINT16 )gDataBuf[ i ] );
			printf( "\n" );
#endif
			if( PeriTestKeyGet( ) ) break;		/* ֹͣ */
		}
	}
#endif
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int	main( void )
{
	UINT32	count;

	mInitSTDIO( );		/* Ϊüͨڼʾ */
	LED_MAIN_WORK_INIT( );
	for( count = 0; count < 10; count ++ )	 /* LED˸ʾ */
	{
		LED_MAIN_WORK_TWK( );
		Delay_ms( 100 );
	}
	PeriTestKeyInit( );	 /* ʼ */
	CH9343Spi0SlvTest( );
	printf( "wait\r\n" );
	while( 1 );
}
/*********************************** endfile **********************************/
