//User must modify the below package with their package name
package com.PWMDemo; 
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.hardware.usb.UsbAccessory;
import android.hardware.usb.UsbManager;
import android.os.Handler;
import android.os.Message;
import android.os.ParcelFileDescriptor;
import android.util.Log;
import android.widget.Toast;


/******************************CH9343 PWM interface class******************************************/
public class WCHPWMInterface extends Activity
{
	
	private static final String ACTION_USB_PERMISSION =    "com.GPIODemo.USB_PERMISSION";
	public UsbManager usbmanager;
	public UsbAccessory usbaccessory;
	public PendingIntent mPermissionIntent;
	public ParcelFileDescriptor filedescriptor;
	public FileInputStream inputstream;
	public FileOutputStream outputstream;
	public boolean mPermissionRequestPending = false;
	
	private byte [] usbdata; 
    private byte []	writeusbdata;
    private int readcount;
    
    public Context global_context;
   
    public static String ManufacturerString = "mManufacturer=WCH";
    public static String ModelString = "mModel=WCHPWMDemo";
    public static String VersionString = "mVersion=1.0";
		
		/*constructor*/
	 public WCHPWMInterface(Context context){
		 	super();
		 	global_context = context;
			/*shall we start a thread here or what*/
			usbdata = new byte[64]; 
	        writeusbdata = new byte[64];
	        
	        /***********************USB handling******************************************/
			
	        usbmanager = (UsbManager) context.getSystemService(Context.USB_SERVICE);
	       // Log.d("LED", "usbmanager" +usbmanager);
	        mPermissionIntent = PendingIntent.getBroadcast(context, 0, new Intent(ACTION_USB_PERMISSION), 0);
	        IntentFilter filter = new IntentFilter(ACTION_USB_PERMISSION);
	        filter.addAction(UsbManager.ACTION_USB_ACCESSORY_DETACHED);
	       context.registerReceiver(mUsbReceiver, filter);
	       
	       inputstream = null;
	       outputstream = null;
		}
	 
	 	/*reset method*/
	 	public void Reset()
	 	{
	 		/*create the packet*/
	 		writeusbdata[0] = 0x22;
			writeusbdata[1] = 0x00;
			writeusbdata[2] = 0x00;
			writeusbdata[3] = 0x00;
			writeusbdata[4] = 0x00;
			
			/*send the packet over the USB*/
			SendPacket((int)5);
	 	}

	 	//period value in milliseconds 
	 	public void SetPeriod(byte period)
	 	{
	 		byte tmp = 0x00;
	 		//CMD code
	 		writeusbdata[0] = 0x20;
	 		
	 		// FIXME, check for minimum and maximum
	 		switch(period)
	 		{
	 		 	case 0: tmp |= 0x00;break;
	 		 	case 1: tmp |= 0x01;break;
	 		 	case 2: tmp |= 0x02;break;
	 		 	case 3: tmp |= 0x03;break;
	 		 	default: tmp |= 0x00;
	 		}
	 		
	 		writeusbdata[1] = tmp;
	 		writeusbdata[2] = 0x00;
	 		writeusbdata[3] = 0x00;
	 		writeusbdata[4] = 0x00;
	 		
	 		//send the packet over the USB
	 		SendPacket((int)5);
	 	}//end
	 		 	

	 	// duty cycle int percentage
	 	public void SetDutyCycle(boolean bothChannel, byte dutyCycle0, byte dutyCycle1)
	 	{
	 		// FIXME, checkfor minimum and maximum
	 		if(dutyCycle0 > 99){
	 			dutyCycle0 = 99;
	 		}
	 		
	 		if(dutyCycle1 > 99) {
	 			dutyCycle1 = 99;
	 		}
	 		// create the packte
	 		writeusbdata[0] = 0x21;
	 		if(bothChannel) {
	 			writeusbdata[1] = dutyCycle0;
	 			writeusbdata[2] = dutyCycle1;
	 		}

	 		writeusbdata[3] = 0x00;
	 		writeusbdata[4] = 0x00;
	 		
	 		//send the packet over the USB
	 		SendPacket((int)5);
	 	}
	 	
		public void SetDutyCycle(byte pwmChannel, byte dutyCycle)
	 	{
	 		// FIXME, checkfor minimum and maximum
	 		if(dutyCycle > 99){
	 			dutyCycle = 99;
	 		}

	 		// create the packte
	 		writeusbdata[0] = 0x21;
	 		switch(pwmChannel)
	 		{
	 			case 0:
	 				writeusbdata[1] = dutyCycle;
	 				writeusbdata[2] = 0x00;
	 				break;  
	 			case 1:
	 				writeusbdata[1] = 0x00;
	 				writeusbdata[2] = dutyCycle;
	 				break; 
	 			case 2:return;
	 			case 3:return;
	 			default:return;
	 		}

	 		writeusbdata[3] = 0x00;
	 		writeusbdata[4] = 0x00;
	 		
	 		//send the packet over the USB
	 		SendPacket((int)5);
	 	}
		
		/*method to send on USB*/
		private void SendPacket(int numBytes)
		{
				
			try {
				if(outputstream != null){
					outputstream.write(writeusbdata, 0,numBytes);
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
	
		
		/*resume accessory*/
		public void ResumeAccessory()
		{
			// Intent intent = getIntent();
			if (inputstream != null && outputstream != null) {
				return;
			}

			UsbAccessory[] accessories = usbmanager.getAccessoryList();
			if(accessories != null)
			{
				Toast.makeText(global_context, "Accessory Attached", Toast.LENGTH_SHORT).show();
			}		
			
			UsbAccessory accessory = (accessories == null ? null : accessories[0]);
			if (accessory != null) 
			{
				if( -1 == accessory.toString().indexOf(ManufacturerString))
				{
					Toast.makeText(global_context, "Manufacturer is not matched!", Toast.LENGTH_SHORT).show();
					return;
				}

				if( -1 == accessory.toString().indexOf(ModelString))
				{
					Toast.makeText(global_context, "Model is not matched!", Toast.LENGTH_SHORT).show();
					return;
				}
				
				if( -1 == accessory.toString().indexOf(VersionString))
				{
					Toast.makeText(global_context, "Version is not matched!", Toast.LENGTH_SHORT).show();
					return;
				}
				
				Toast.makeText(global_context, "Manufacturer, Model & Version are matched!", Toast.LENGTH_SHORT).show();
				
				if (usbmanager.hasPermission(accessory)) 
				{
					OpenAccessory(accessory);
				} 
				else
				{
					synchronized (mUsbReceiver) 
					{
						if (!mPermissionRequestPending) {
							Toast.makeText(global_context, "Request USB Permission", Toast.LENGTH_SHORT).show();
							usbmanager.requestPermission(accessory,
									mPermissionIntent);
							mPermissionRequestPending = true;
						}
					}
				}
			}
		}
		
		/*destroy accessory*/
		public void DestroyAccessory(){
			Reset();
			SetDutyCycle((byte)0,(byte)0);
			SetDutyCycle((byte)1,(byte)0);
			SetDutyCycle((byte)2,(byte)0);
			SetDutyCycle((byte)3,(byte)0);
			CloseAccessory();
		}
		

		
/*********************helper routines*************************************************/		
		
		public void OpenAccessory(UsbAccessory accessory)
		{
			filedescriptor = usbmanager.openAccessory(accessory);			
			if(filedescriptor != null){
				usbaccessory = accessory;
				FileDescriptor fd = filedescriptor.getFileDescriptor();
				inputstream = new FileInputStream(fd);
				outputstream = new FileOutputStream(fd);
				/*check if any of them are null*/
				if(inputstream == null || outputstream==null){
					return;
				}
			}
		}
		
		private void CloseAccessory()
		{
			try{
				if(filedescriptor != null)
					filedescriptor.close();
				
			}catch (IOException e){}
			
			try {
				if(inputstream != null)
						inputstream.close();
			} catch(IOException e){}
			
			try {
				if(outputstream != null)
						outputstream.close();
				
			}catch(IOException e){}
			/*FIXME, add the notification also to close the application*/
			
			filedescriptor = null;
			inputstream = null;
			outputstream = null;
			
			System.exit(0);
		}		
				
		/***********USB broadcast receiver*******************************************/
	    private final BroadcastReceiver mUsbReceiver = new BroadcastReceiver() 
		{
			@Override
			public void onReceive(Context context, Intent intent) 
			{
				String action = intent.getAction();
				if (ACTION_USB_PERMISSION.equals(action)) 
				{
					synchronized (this)
					{
						UsbAccessory accessory = (UsbAccessory) intent.getParcelableExtra(UsbManager.EXTRA_ACCESSORY);
						if (intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false))
						{
							Toast.makeText(global_context, "Allow USB Permission", Toast.LENGTH_SHORT).show();
							OpenAccessory(accessory);
						} 
						else 
						{
							Toast.makeText(global_context, "Deny USB Permission", Toast.LENGTH_SHORT).show();
							//Log.d("LED", "permission denied for accessory "+ accessory);
							
						}
						mPermissionRequestPending = false;
					}
				} 
				else if (UsbManager.ACTION_USB_ACCESSORY_DETACHED.equals(action)) 
				{
					CloseAccessory();
				}else
				{
					//Log.d("LED", "....");
				}
			}	
		};
	    
	}